
/*
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of the VirtualBox SDK, as available from
 * http://www.virtualbox.org.  This library is free software; you can
 * redistribute it and/or modify it under the terms of the GNU Lesser General
 * Public License as published by the Free Software Foundation, in version 2.1
 * as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * IEmulatedUSB.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_5_2;

import org.virtualbox_5_2.jaxws.*;
import javax.xml.ws.*;
import java.util.List;


/**
Manages emulated USB devices.

Interface ID: <tt>{6E253EE8-477A-2497-6759-88B8292A5AF0}</tt>
*/
public class IEmulatedUSB extends IUnknown
{

    public IEmulatedUSB(String wrapped, ObjectRefManager objMgr, VboxPortType port)
    {
        super(wrapped, objMgr, port);
    }

/**
Lists attached virtual webcams.
@return List&lt;String&gt;
*/
    public List<String> getWebcams()
    {
        try
        {
            List<String> retVal = port.iEmulatedUSBGetWebcams(obj);
            return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }
    public static IEmulatedUSB queryInterface(IUnknown obj)
    {
        return obj == null ?  null : new IEmulatedUSB(obj.getWrapped(), obj.getObjMgr(), obj.getRemoteWSPort());
    }

/**
Attaches the emulated USB webcam to the VM, which will use a host video capture device.
@param path The host path of the capture device to use.

@param settings Optional settings.

*/
    public void webcamAttach(String path, String settings)
    {
        try
        {
        port.iEmulatedUSBWebcamAttach(obj, path, settings);
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Detaches the emulated USB webcam from the VM
@param path The host path of the capture device to detach.

*/
    public void webcamDetach(String path)
    {
        try
        {
        port.iEmulatedUSBWebcamDetach(obj, path);
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }
}
